VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Pachube VB6"
   ClientHeight    =   1590
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   2880
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1590
   ScaleWidth      =   2880
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdUploadEEML 
      Caption         =   "Upload the Data"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   2415
   End
   Begin VB.CommandButton cmdCreateEEML 
      Caption         =   "Create the data"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   2415
   End
   Begin VB.Frame Frame2 
      Caption         =   "EEML Update"
      Height          =   1335
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim xmlmsg As String
Dim Pachube_input As String
Dim Pachube_key As String
'

Private Sub cmdCreateEEML_Click()
Call create_xml
End Sub

Private Sub cmdCSVUpdate_Click()
Call Send_CSV
End Sub

Private Sub cmdUploadEEML_Click()
Call send_xml
End Sub

Private Sub Form_Load()
    ' Your feed url goes here
    ' Should look like http://www.pachube.com/api/1234.xml
    ' ie it has the "api" in it not "feeds"
    Pachube_input = "http://www.pachube.com/api/1590.xml"
    ' Your allocated API key goes here and must be associated with the input
    Pachube_key = ""

End Sub

Private Sub send_xml()
Debug.Print "send_xml"
Dim WinHTTPreq As WinHttp.WinHttpRequest
If Trim(Pachube_input) = "" Then Exit Sub
If Trim(Pachube_key) = "" Then Exit Sub

    Set WinHTTPreq = New WinHttpRequest
    url = Pachube_input + "?key=" + Pachube_key
    Debug.Print url
    
    Err.Clear
    On Error Resume Next '

    WinHTTPreq.Open "PUT", url, False
    
    WinHTTPreq.SetTimeouts 10000, 10000, 10000, 10000
    Err.Clear
    On Error Resume Next '
    PachubeXMLMessage = xmlmsg
    
    WinHTTPreq.Send (PachubeXMLMessage)
    
    statusmsg = WinHTTPreq.ResponseText
    sc = WinHTTPreq.Status
    If sc = 200 Then statusmsg = "Success"
    
    last_response = sc & " - " & statusmsg
    Debug.Print "Last response "; last_response
    
    Set WinHTTPreq = Nothing
End Sub
Private Sub create_xml()
Debug.Print "create_xml"
Dim data0, data1, data2, data3, head, tail As String

' for  the demo data
Dim tempc, elec1, elec2, elec3 As String
'demo data
    tempc = "22.99"
    elec1 = "1001"
    elec2 = "0.2"
    elec3 = "0.3"
    
Dim doc As New DOMDocument30
    doc.async = False
    doc.validateOnParse = False
    doc.resolveExternals = False
    head = "<?xml version='1.0' encoding='UTF-8' ?> " + vbNewLine + _
        "<eeml xmlns='http://www.eeml.org/xsd/005' xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xsi:schemaLocation='http://www.eeml.org/xsd/005 http://www.eeml.org/xsd/005/005.xsd'>" + vbNewLine + _
        "<environment>" + vbNewLine
    data0 = "<data id='0'>" + vbNewLine + _
            "<tag>temperature</tag>" + vbNewLine + _
            "<value minValue='-5' maxValue='35'>" + tempc + "</value>" + vbNewLine + _
            "<unit symbol='C' type='derivedSI'>Celsius</unit>" + vbNewLine + _
        "</data>" + vbNewLine
    data1 = "<data id='1'>" + vbNewLine + _
            "<tag>Consumption 1</tag>" + vbNewLine + _
            "<value minValue='0' maxValue='5000'>" + elec1 + "</value>" + vbNewLine + _
            "<unit symbol='W' type='derivedSI'>Watts</unit>" + vbNewLine + _
        "</data>" + vbNewLine
    data2 = "<data id='2'>" + vbNewLine + _
            "<tag>Consumption 2</tag>" + vbNewLine + _
            "<value minValue='0' maxValue='5000'>" + elec2 + "</value>" + vbNewLine + _
            "<unit symbol='W' type='derivedSI'>Watts</unit>" + vbNewLine + _
        "</data>" + vbNewLine
    data3 = "<data id='3'>" + vbNewLine + _
            "<tag>Consumption 3</tag>" + vbNewLine + _
            "<value minValue='0' maxValue='5000'>" + elec3 + "</value>" + vbNewLine + _
            "<unit symbol='W' type='derivedSI'>Watts</unit>" + vbNewLine + _
        "</data>" + vbNewLine
   tail = "</environment>" + vbNewLine + _
        "</eeml>" + vbNewLine
    
    doc.loadXML head + data0 + data1 + data2 + data3 + tail
        
    'Debug.Print doc.xml
    xmlmsg = doc.xml
    
    ' not required, for diagnostics only
    Path = App.Path + "\pacc.xml"
    doc.save Path

End Sub

